/*
 * Copyright © 2022 Soren Stoutner <soren@stoutner.com>.
 *
 * This file is part of Privacy Browser PC <https://www.stoutner.com/privacy-browser-pc>.
 *
 * Privacy Browser PC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Privacy Browser PC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Privacy Browser PC.  If not, see <http://www.gnu.org/licenses/>.
 */

// Application headers.
#include "UserAgentHelper.h"

// The default constructor.
UserAgentHelper::UserAgentHelper() {};

QString UserAgentHelper::getUserAgent(const QString &userAgentName)
{
    if (userAgentName == "Privacy Browser")  // Privacy Browser.
    {
        return "PrivacyBrowser/1.0";
    }
    else if (userAgentName == "Firefox Linux")  // Firefox Linux.
    {
        return "Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101 Firefox/91.0";
    }
    else if (userAgentName == "Chromium Linux")  // Chromium Linux.
    {
        return "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36";
    }
    else if (userAgentName == "Firefox Windows")  // Firefox Windows.
    {
        return "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:97.0) Gecko/20100101 Firefox/97.0";
    }
    else if (userAgentName == "Chrome Windows")  // Chrome Windows.
    {
        return "Mozilla/5.0 (Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36";
    }
    else if (userAgentName == "Edge Windows")  // Edge Windows.
    {
        return "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36 Edg/98.0.1108.56";
    }
    else if (userAgentName == "Safari macOS")  // Safari macOS.
    {
        return "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.1 Safari/605.1.15";
    }
    else
    {
        // Return the custom user agent.
        return userAgentName;
    }
}
